package edu.berkeley.sbp;
import java.io.*;
import java.util.*;
import java.lang.reflect.*;
import java.lang.ref.*;
import edu.berkeley.sbp.*;
import edu.berkeley.sbp.util.*;

/** a stream of tokens to be parsed */
public interface Input<Token> {

    /** returns the token just beyond the current location and advances beyond it */
    public Token           next() throws IOException;

    /** returns the location the input stream is currently at */
    public Location<Token> getLocation();

    /** a location <i>between tokens<i> in the input stream */
    public static interface Location<Tok> extends Comparable<Location> {
        public String toString();
        public Region<Tok> createRegion(Location<Tok> loc);
    }

    public static interface Region<Tok> /* implements Topology<Location<Tok>> */ { }
}


